﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RF_TRIO_PLL_ZIG
{
    public enum Bluepro_t
    {
        bluecell_header0 = 0,
        bluecell_header1,
        bluecell_header2,
        bluecell_header3,
        bluecell_type,
        bluecell_length_h,
        bluecell_length_l,
        bluecell_updatecnt_h,
        bluecell_updatecnt_l,
        bluecell_data,

    };
    public enum Updateseq
    {
        Bluecell_Reset = 0,
        Bluecell_Firmupdate_start,
        Bluecell_Firmupdate_sending,
        Bluecell_Firmupdate_end,
    };
    enum Bluecell_ProtIndex_p
    {
        Bluecell_Header = 0,
        Bluecell_Type,
        Bluecell_Length,
        Bluecell_CrcIndex,
        Bluecell_data,
    }
    enum Bluecell_Prot_t{
        TYPE_BLUECELL_RESET = 0,
        TYPE_BLUECELL_SET   = 1,
        TYPE_BLUECELL_GET   = 2,
    };
    enum Bluecell_TypeIndex_t
    {
        ATT_1_8G_DL1 = 0,
        ATT_1_8G_DL2,

        ATT_1_8G_UL1,
        ATT_1_8G_UL2,
        ATT_1_8G_UL3,
        ATT_1_8G_UL4,

        ATT_2_1G_DL1,
        ATT_2_1G_DL2,

        ATT_2_1G_UL1,
        ATT_2_1G_UL2,
        ATT_2_1G_UL3,
        ATT_2_1G_UL4,

        ATT_3_5G_DL,
        ATT_3_5G_UL,
        ATT_3_5G_COM1,
        ATT_3_5G_COM2,
        ATT_3_5G_COM3,

        PLL_1_8G_DL1_H,
        PLL_1_8G_DL1_L,
        PLL_1_8G_DL2_H,
        PLL_1_8G_DL2_L,

        PLL_2_1G_DL1_H,
        PLL_2_1G_DL1_L,
        PLL_2_1G_DL2_H,
        PLL_2_1G_DL2_L,

        PLL_3_5G_DL1_H,
        PLL_3_5G_DL1_L,
        PLL_3_5G_DL2_H,
        PLL_3_5G_DL2_L,

        PLL_LD_6_BIT,

        DET_1_8G_DL_IN_H,
        DET_1_8G_DL_IN_L,
        DET_1_8G_DL_OUT_H,
        DET_1_8G_DL_OUT_L,
        DET_1_8G_UL_IN_H,
        DET_1_8G_UL_IN_L,
        DET_1_8G_UL_OUT_H,
        DET_1_8G_UL_OUT_L,
        DET_2_1G_DL_IN_H,
        DET_2_1G_DL_IN_L,
        DET_2_1G_DL_OUT_H,
        DET_2_1G_DL_OUT_L,
        DET_2_1G_UL_IN_H,
        DET_2_1G_UL_IN_L,
        DET_2_1G_UL_OUT_H,
        DET_2_1G_UL_OUT_L,
        DET_3_5G_DL_IN_H,
        DET_3_5G_DL_IN_L,
        DET_3_5G_DL_OUT_L,
        DET_3_5G_DL_OUT_H,
        DET_3_5G_UL_IN_H,
        DET_3_5G_UL_IN_L,
        DET_3_5G_UL_OUT_H,
        DET_3_5G_UL_OUT_L,
        RFU_TEMP_H,
        RFU_TEMP_L,
        _28V_DET_H,
        _28V_DET_L,
        ALARM_AC,
        ALARM_DC,
        PATH_EN_1_8G_DL,
        PATH_EN_1_8G_UL,
        PATH_EN_2_1G_DL,
        PATH_EN_2_1G_UL,
        PATH_EN_3_5G_L,
        PATH_EN_3_5G_H,
        PATH_EN_3_5G_DL,
        PATH_EN_3_5G_UL,
        PLL_ON_OFF_3_5G_H,
        PLL_ON_OFF_3_5G_L,
    };
    class Bluecell_BootProtocol
    {
        Serial serial;

        /*bluecell Header*/
        public const byte Bluecell_Header0 = 0x42;//ASCII : B
        public const byte Bluecell_Header1 = 0x4C;//ASCII : L
        public const byte Bluecell_Header2 = 0x55;//ASCII : U
        public const byte Bluecell_Header3 = 0x45;//ASCII : E
        /*bluecell type*/


        public const int bluecell_Firmupdate_sendlength = 1024;

        
        Crc16 crc16 = new Crc16();

        public const byte BLUECELL_HEADER = 0xBE;
        public const byte BLUECELL_TAILER = 0xEB;
        const byte BLUECELL_RESET_LENGTH = 6;
        const byte BLUECELL_FIX_DATA_LENGTH = 3;

        public void Bluecell_Reset(object serial)
        {
            this.serial = (Serial)serial;
            byte[] temp_buf = new byte[BLUECELL_RESET_LENGTH];
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_Header]       = BLUECELL_HEADER;
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_Type]         = (byte)Bluecell_Prot_t.TYPE_BLUECELL_RESET;
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_Length]       = BLUECELL_RESET_LENGTH - BLUECELL_FIX_DATA_LENGTH;
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_CrcIndex]     = (byte)Bluecell_ProtIndex_p.Bluecell_data;
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data]         = crc16.STH30_CreateCrc(temp_buf, BLUECELL_RESET_LENGTH - 3);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + 1]     = BLUECELL_TAILER;
            this.serial.Serial_DataSend(temp_buf, temp_buf.Length);
        }
        const byte BLUECELL_DATA_SET_LENGTH = 62;
        public void Bluecell_BtnSet(object serial,object main_form)
        {
            Main_Form main_Form = (Main_Form)main_form;
            this.serial = (Serial)serial;
            byte[] temp_buf = new byte[BLUECELL_DATA_SET_LENGTH];
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_Header]   = BLUECELL_HEADER;
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_Type]     = (byte)Bluecell_Prot_t.TYPE_BLUECELL_SET;
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_Length]   = BLUECELL_RESET_LENGTH - BLUECELL_FIX_DATA_LENGTH;
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_CrcIndex] = (byte)BLUECELL_DATA_SET_LENGTH - 2;




            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_1_8G_DL1] = Convert.ToByte(main_Form.numericUpDown_ATT_1_8G_DL1.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_1_8G_DL2] = Convert.ToByte(main_Form.numericUpDown_ATT_1_8G_DL2.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_1_8G_UL1] = Convert.ToByte(main_Form.numericUpDown_ATT_1_8G_UL1.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_1_8G_UL2] = Convert.ToByte(main_Form.numericUpDown_ATT_1_8G_UL2.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_1_8G_UL3] = Convert.ToByte(main_Form.numericUpDown_ATT_1_8G_UL3.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_1_8G_UL4] = Convert.ToByte(main_Form.numericUpDown_ATT_1_8G_UL4.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_2_1G_DL1] = Convert.ToByte(main_Form.numericUpDown_ATT_2_1G_DL1.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_2_1G_DL2] = Convert.ToByte(main_Form.numericUpDown_ATT_2_1G_DL2.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_2_1G_UL1] = Convert.ToByte(main_Form.numericUpDown_ATT_2_1G_UL1.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_2_1G_UL2] = Convert.ToByte(main_Form.numericUpDown_ATT_2_1G_UL2.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_2_1G_UL3] = Convert.ToByte(main_Form.numericUpDown_ATT_2_1G_UL3.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_2_1G_UL4] = Convert.ToByte(main_Form.numericUpDown_ATT_2_1G_UL4.Text);
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_3_5G_DL] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_3_5G_UL] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_3_5G_COM1] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_3_5G_COM2] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ATT_3_5G_COM3] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_1_8G_DL1_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_1_8G_DL1_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_1_8G_DL2_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_1_8G_DL2_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_2_1G_DL1_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_2_1G_DL1_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_2_1G_DL2_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_2_1G_DL2_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_3_5G_DL1_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_3_5G_DL1_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_3_5G_DL2_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_3_5G_DL2_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_LD_6_BIT] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_1_8G_DL_IN_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_1_8G_DL_IN_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_1_8G_DL_OUT_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_1_8G_DL_OUT_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_1_8G_UL_IN_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_1_8G_UL_IN_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_1_8G_UL_OUT_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_1_8G_UL_OUT_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_2_1G_DL_IN_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_2_1G_DL_IN_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_2_1G_DL_OUT_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_2_1G_DL_OUT_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_2_1G_UL_IN_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_2_1G_UL_IN_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_2_1G_UL_OUT_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_2_1G_UL_OUT_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_3_5G_DL_IN_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_3_5G_DL_IN_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_3_5G_DL_OUT_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_3_5G_DL_OUT_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_3_5G_UL_IN_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_3_5G_UL_IN_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_3_5G_UL_OUT_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.DET_3_5G_UL_OUT_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.RFU_TEMP_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.RFU_TEMP_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t._28V_DET_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t._28V_DET_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ALARM_AC] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.ALARM_DC] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PATH_EN_1_8G_DL] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PATH_EN_1_8G_UL] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PATH_EN_2_1G_DL] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PATH_EN_2_1G_UL] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PATH_EN_3_5G_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PATH_EN_3_5G_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PATH_EN_3_5G_DL] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PATH_EN_3_5G_UL] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_ON_OFF_3_5G_H] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_ON_OFF_3_5G_L] =
            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + (int)Bluecell_TypeIndex_t.PLL_ON_OFF_3_5G_L + 1] = crc16.STH30_CreateCrc(temp_buf, BLUECELL_RESET_LENGTH - 3);

            temp_buf[(int)Bluecell_ProtIndex_p.Bluecell_data + 1] = BLUECELL_TAILER;
            this.serial.Serial_DataSend(temp_buf, temp_buf.Length);
        }
#if false
        public int Bluecell_Firmupdate_sendlength() {
            return bluecell_Firmupdate_sendlength;
        }

        private void BootHeaderput(ref byte[] fix_data)
        {
            fix_data[(int)Bluepro_t.bluecell_header0] = Bluecell_Header0;
            fix_data[(int)Bluepro_t.bluecell_header1] = Bluecell_Header1;
            fix_data[(int)Bluepro_t.bluecell_header2] = Bluecell_Header2;
            fix_data[(int)Bluepro_t.bluecell_header3] = Bluecell_Header3;
        }

        public byte[] Boot_Reset(object serial,byte[] Updatedata)
        {
            this.serial = (Serial)serial;
            byte[] fix_data = new byte[11];
            //Array.Clear(data, 0, data.Length);
            BootHeaderput(ref fix_data);
            fix_data[(int)Bluepro_t.bluecell_type]    = (byte)Updateseq.Bluecell_Reset;
            fix_data[(int)Bluepro_t.bluecell_length_h]  = 0;
            fix_data[(int)Bluepro_t.bluecell_length_l]  = 5;
            fix_data[(int)Bluepro_t.bluecell_updatecnt_h] = Convert.ToByte((Updatedata.Length & 0xFF00) >> 8);
            fix_data[(int)Bluepro_t.bluecell_updatecnt_l] = Convert.ToByte((Updatedata.Length & 0x00FF));

            fix_data[(int)Bluepro_t.bluecell_data + 0] = Convert.ToByte((crc16.CRC16_Generate(fix_data, fix_data.Length - 4) & 0xFF00) >> 8);
            fix_data[(int)Bluepro_t.bluecell_data + 1] = Convert.ToByte((crc16.CRC16_Generate(fix_data, fix_data.Length - 4) & 0x00FF));
            this.serial.Serial_DataSend(fix_data, fix_data.Length);
            return fix_data;            
        }
     
        public byte[] Boot_DataSending(byte[] update_data,UInt16 length, UInt16 updatacnt)
        {
            //Array.Clear(data, 0, data.Length);
            byte[] fix_data = new byte[bluecell_Firmupdate_sendlength];
            //BootHeaderput(ref fix_data);
            //length += 5;
            Array.Copy(update_data, (int)Bluepro_t.bluecell_data, fix_data, (int)Bluepro_t.bluecell_data, length);
            BootHeaderput(ref fix_data);
            fix_data[(int)Bluepro_t.bluecell_type] = (byte)Updateseq.Bluecell_Firmupdate_sending;
            fix_data[(int)Bluepro_t.bluecell_length_h] = Convert.ToByte((length & 0xFF00) >> 8);
            fix_data[(int)Bluepro_t.bluecell_length_l] = Convert.ToByte((length & 0x00FF));
            fix_data[(int)Bluepro_t.bluecell_updatecnt_h] = Convert.ToByte((updatacnt & 0xFF00) >> 8);
            fix_data[(int)Bluepro_t.bluecell_updatecnt_l] = Convert.ToByte((updatacnt & 0x00FF));

            //Array.Copy(update_data, 0, fix_data, (int)Bluepro_t.bluecell_data, length-3);
            fix_data[length + 9] = Convert.ToByte((crc16.CRC16_Generate(fix_data, length + 5) & 0xFF00) >> 8);
            fix_data[length + 10] = Convert.ToByte(crc16.CRC16_Generate(fix_data, length + 5) & 0x00FF);
            return fix_data;
        }
        public byte[] Boot_DataEnd(byte[] update_data, int length)
        {
            //Array.Clear(data, 0, data.Length);
            byte[] fix_data = new byte[11];
            Array.Copy(update_data, (int)Bluepro_t.bluecell_data, fix_data, (int)Bluepro_t.bluecell_data, length);
            BootHeaderput(ref fix_data);
            fix_data[(int)Bluepro_t.bluecell_type]    = (byte)Updateseq.Bluecell_Firmupdate_end;
            fix_data[(int)Bluepro_t.bluecell_length_h] = Convert.ToByte((length & 0xFF00) >> 8);
            fix_data[(int)Bluepro_t.bluecell_length_l] = Convert.ToByte((length & 0x00FF));
            fix_data[(int)Bluepro_t.bluecell_updatecnt_h] = 0;
            fix_data[(int)Bluepro_t.bluecell_updatecnt_l] = 0;

            //Array.Copy(update_data, 0, fix_data, (int)Bluepro_t.bluecell_data, length-3);
            fix_data[length + 9] = Convert.ToByte((crc16.CRC16_Generate(fix_data, length + 5) & 0xFF00) >> 8);
            fix_data[length + 10] = Convert.ToByte(crc16.CRC16_Generate(fix_data, length + 5) & 0x00FF);
            return fix_data;
        }

#endif
    }
    }
